/*
  Ex8_3
  Insert a section into a list.
  This program can insert a item at the begin of a list
*/

struct entry
{
    int          value;
    struct entry *next;
};

void display(top)
struct entry *top;   /* start of list */
{
    printf("Elements in the list are (as follow) :\n");
    while (top)
    {
        printf("%6d",top->value);
        top = top->next;
    }
    printf("\n");
}


struct entry *insert_entry(pre_ptr,ptr,top_ptr)
struct entry *pre_ptr;   /* pointer of previous item  */
struct entry *ptr;       /* pointer of item to insert */
struct entry *top_ptr;   /* pointer of first item     */
{
    if (pre_ptr)
    {
	 ptr->next = pre_ptr->next;
         pre_ptr->next = ptr;
	 return top_ptr;
    }
    else 
    {                     /* To insert at the begin of list, */
	 ptr->next = top_ptr;       /* pre_ptr must be 0               */
	 return ptr;
    }
}

main()
{
    struct entry n1,n2,n3,n4;   /* items of list */
    struct entry *list_head_ptr= &n1;

    /* initialize the item */
    n1.value=100;
    n2.value=200;
    n3.value=300;
    n4.value=400;
    n1.next =0;

    /* insert each item into list */
    list_head_ptr=insert_entry(0,&n2,list_head_ptr);  /* insert at the begin */
    list_head_ptr=insert_entry(&n1,&n3,list_head_ptr);
    list_head_ptr=insert_entry(0,&n4,list_head_ptr);

    /* print list */
    display(list_head_ptr);
}

