/*
  Ex8_2
  Insert an entry into a list 
*/

struct entry
{
    int          value;
    struct entry *next;
};

void display(top)
struct entry *top;   /* start of list */
{
    printf("Elements in the list are (as follow) :\n");
    while (top) 
    {
        printf("%6d",top->value);
        top=top->next;
    }
    printf("\n");
}

void insert_entry(pre_ptr,ptr)
struct entry *pre_ptr;   /* pointer of previous item  */
struct entry *ptr;       /* pointer of item to insert */
{
    ptr->next=pre_ptr->next;
    pre_ptr->next=ptr;
}

main()
{
    struct entry n1,n2,n3,n4;   /* items of list */

    /* initialize the item */
    n1.value=100;
    n2.value=200;
    n3.value=300;
    n4.value=400;
    n1.next =0;

    /* insert each item into list */
    insert_entry(&n1,&n2);
    insert_entry(&n2,&n3);
    insert_entry(&n2,&n4);

    /* print list */
    display(&n1);
}

