
/* 
  Ex8_4
  Remove an entry from a list 
*/

struct entry
{
    int          value;
    struct entry *next;
};

void display(top)
struct entry *top;   /* start of list */
{
    printf("Elements in the list are (as follow) :\n");
    while (top) 
    {
        printf("%6d",top->value);
        top=top->next;
    }
    printf("\n");
}

void insert_entry(pre_ptr,ptr)
struct entry *pre_ptr;   /* pointer of previous item  */
struct entry *ptr;       /* pointer of item to insert */
{
    ptr->next=pre_ptr->next;
    pre_ptr->next=ptr;
}

void remove(prev_ptr)
struct entry *prev_ptr;
{
    if (!prev_ptr->next) return;
    prev_ptr->next=prev_ptr->next->next;
}

main()
{
    struct entry n1,n2,n3,n4,list_head;   /* items of list */

    /* initialize the item */
    n1.value=100;
    n2.value=200;
    n3.value=300;
    n4.value=400;
    n1.next =0;
    list_head.next= &n1;

    /* insert each item into list */
    insert_entry(&list_head,&n2);
    insert_entry(&n1,&n3);
    insert_entry(&list_head,&n4);
    display(list_head.next);

    /* remove item  and print list */
    remove(&list_head);   /* remove the first item */
    printf("Remove the first item of the list ...\n");
    display(list_head.next);
    remove(&n1);
    printf("Remove middle item of the list ...\n");
    display(list_head.next);
}

